package com.example.grok.concurrencyproject;

import android.app.Activity;
import android.app.ActivityManager;
import android.app.LoaderManager;
import android.content.AsyncTaskLoader;
import android.content.Context;
import android.content.Loader;
import android.graphics.Bitmap;
import android.media.Image;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.SystemClock;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.View;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Adapter;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.Toast;

import java.lang.ref.WeakReference;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class MainActivity extends AppCompatActivity implements LoaderManager.LoaderCallbacks<List<String>> {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        final MyLooper myLooper1 = new MyLooper(1);

        ActivityManager.MemoryInfo mi = new ActivityManager.MemoryInfo();
        ActivityManager activityManager = (ActivityManager) getSystemService(ACTIVITY_SERVICE);
        activityManager.getMemoryInfo(mi);
        long availableMegs = mi.availMem / 1048576L;
        Log.e("Memory", " " + availableMegs);
        LoaderManager manager= getLoaderManager();
        manager.initLoader(31337, null, this);
        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                Message msg = new Message();
                Bundle mBundle = new Bundle();
                mBundle.putString("KEY", "textMessage");
                msg.setData(mBundle);
                myLooper1.mHandler.sendMessage(msg);

              //  getLoaderManager().initLoader(31337, null, (android.app.LoaderManager.LoaderCallbacks<List<String>>) view.getContext()).forceLoad();
            }
        });


        myLooper1.start();
        ImageView img = (ImageView)findViewById(R.id.imageView);

       // new MyTask(img).execute("hello");
        URL url;
        try {
            url = new URL("aaa");
            new FileCryptor().execute(url);
        } catch (MalformedURLException e) {
            e.printStackTrace();
        }



    }

    public void ViewClick(View v)
    {
     Log.e("Thread", "view clicked");
    }
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public Loader<List<String>> onCreateLoader(int id, Bundle args) {

        MyLoader myLoader = new MyLoader(this);
        return myLoader;
    }

    @Override
    public void onLoadFinished(Loader<List<String>> loader, List<String> data) {

        final ListView lv = (ListView)findViewById(R.id.listView);
        final ArrayAdapter<String>adapter;
        adapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1,data);

        lv.setAdapter(adapter);

    }

    @Override
    public void onLoaderReset(Loader<List<String>> loader) {
        final ListView lv = (ListView)findViewById(R.id.listView);
        lv.setAdapter(null);

    }

    private class MyTask extends AsyncTask<String, Void, Bitmap> {
        WeakReference<ImageView> wImage;

        MyTask(ImageView imageView) {
            wImage = new WeakReference<ImageView>(imageView);
        }

        @Override
        protected Bitmap doInBackground(String... params) {

            return loadImage(params[0]);

        }

        private Bitmap loadImage(String a) {
            return null;
        }

        @Override
        protected void onPostExecute(Bitmap bitmap) {
            final ImageView imageView = wImage.get();
            if (imageView != null) {
                imageView.setImageBitmap(bitmap);
                super.onPostExecute(bitmap);
            }
        }
    }

    private static class MyLoader extends AsyncTaskLoader<List<String>>
    {

        public MyLoader(Context context) {
            super(context);
        }

        @Override
        public List<String> loadInBackground() {
            Log.e("Thread", "started");
            SystemClock.sleep(5000);
            List<String> list = Arrays.asList("aa","bb");
            Log.e("Thread", "finished");

            return list;
        }
    }

    private class FileCryptor extends AsyncTask<URL, Integer, String> {
        @Override
        protected String doInBackground(URL... params) {
            return null;
        }
    }
}
